<?php
/* --------------------------------------------------------------
   dependent.inc.php 2022-09-15
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2022 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------*/

/** @var DatabaseModel $this */
/** @var bool $t_success */

$check = $this->query('SELECT `value` FROM `gx_configurations` WHERE `key` = "gm_configuration/APILAYER_API_KEY"',
                      true);

if ($check->num_rows < 1) {
    $query     = 'INSERT INTO `gx_configurations` SET `key` = "gm_configuration/APILAYER_API_KEY", `value` = "", `default` = "", `sort_order` = 0';
    $t_success &= $this->query($query, true);
}

$query  = 'SELECT `customers_email_address` AS email, COUNT(`customers_email_address`) AS cnt FROM `customers` GROUP BY `customers_email_address` HAVING cnt > 1';
$emails = $this->query($query);

$duplicateEmails = [];
foreach ($emails as $email) {
    $duplicateEmails[] = $email['email'];
}

if (count($duplicateEmails)) {
    $customerIdsResult = $this->query('SELECT customers_id AS `id` FROM `customers` WHERE account_type = 1 AND customers_email_address IN ("'
                                      . implode('","', $duplicateEmails) . '")');
    $customerIds       = [];
    foreach ($customerIdsResult as $customerId) {
        $customerIds[] = $customerId['id'];
    }
    if (count($customerIds)) {
        $query     = 'DELETE FROM admin_access_users WHERE customer_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM customers_basket WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM customers_basket_attributes WHERE customers_id IN (' . implode(',', $customerIds)
                     . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM customers_ip WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM customers_status_history WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM customers_wishlist WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM customers_wishlist_attributes WHERE customers_id IN (' . implode(',', $customerIds)
                     . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM coupon_gv_customer WHERE customer_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM gm_gprint_cart_elements WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM gm_gprint_wishlist_elements WHERE customers_id IN (' . implode(',', $customerIds)
                     . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM products_notifications WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM whos_online WHERE customer_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM customers_info WHERE customers_info_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM customers_memo WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM shared_shopping_carts WHERE customer_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'DELETE FROM address_book WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    
        $query     = 'UPDATE coupon_redeem_track SET customer_id = 0 WHERE customer_id IN (' . implode(',',
                                                                                                       $customerIds)
                     . ')';
        $t_success &= is_numeric($this->query($query));
    
        $query     = 'UPDATE coupon_gv_queue SET customer_id = 0 WHERE customer_id IN (' . implode(',', $customerIds)
                     . ')';
        $t_success &= is_numeric($this->query($query));
    
        $query     = 'UPDATE coupon_redeem_track SET customer_id = 0 WHERE customer_id IN (' . implode(',',
                                                                                                       $customerIds)
                     . ')';
        $t_success &= is_numeric($this->query($query));
    
        $query     = 'UPDATE gm_gprint_uploads SET customers_id = 0 WHERE customers_id IN (' . implode(',',
                                                                                                       $customerIds)
                     . ')';
        $t_success &= is_numeric($this->query($query));
    
        $query     = 'UPDATE newsletter_recipients SET customers_id = 0 WHERE customers_id IN (' . implode(',',
                                                                                                           $customerIds)
                     . ')';
        $t_success &= is_numeric($this->query($query));
    
        $query     = 'UPDATE orders SET customers_id = 0 WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= is_numeric($this->query($query));
    
        $query     = 'UPDATE withdrawals SET customer_id = 0 WHERE customer_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= is_numeric($this->query($query));
    
        $query     = 'DELETE FROM customers WHERE customers_id IN (' . implode(',', $customerIds) . ')';
        $t_success &= $this->query($query, true);
    }
}

if ($this->table_exists('gkv_shipments') && !$this->columnExists('gkv_shipments', 'returnshipmentnumber')) {
    $query     = "ALTER TABLE `gkv_shipments` ADD `returnshipmentnumber` VARCHAR(39) NOT NULL DEFAULT '' AFTER `shipmentnumber`";
    $t_success &= $this->query($query, true);
}
