<?php
/*--------------------------------------------------------------
   mailbeez_info_message.php 2022-07-08
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2022 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------*/

$mailbeezFile = DIR_FS_CATALOG . 'ext/mailhive/common/classes/mailbeez_configuration_wrapper.php';
if (file_exists($mailbeezFile)) {
    $mailbeezFileContent = file_get_contents($mailbeezFile);
    
    if(strpos($mailbeezFileContent, "version_compare(MH_PLATFORM_GAMBIO_GX_VERSION, '4.5', '>=')") === false) {
        include_once DIR_FS_CATALOG . 'GambioCore/Application/env.php';
    
        $securityToken = Gambio\Core\Application\env('APP_SECURITY_TOKEN');
    
        if ($securityToken === null && is_dir(DIR_FS_CATALOG . 'media')) {
            $dir = opendir(DIR_FS_CATALOG . 'media');
            if ($dir !== false) {
                while (($file = readdir($dir)) !== false) {
                    // search for secure token file
                    if (strpos($file, 'secure_token_') !== false) {
                        $securityToken = str_replace('secure_token_', '', $file);
                        break;
                    }
                }
            }
        }
    
        $mailbeezUpdaterUrl = HTTP_SERVER . DIR_WS_CATALOG . 'admin/mailbeez.php?cloudloader_mode=update_core';
    
        $hash = '&return_url_hash=' . hash('sha256',
                                           $mailbeezUpdaterUrl . $securityToken);
    
        $mailbeezUpdaterUrl = HTTP_SERVER . DIR_WS_CATALOG . 'login.php?login_admin&return_url='
                              . rawurlencode($mailbeezUpdaterUrl) . $hash;
    
        echo '<span class="alert alert-danger">
                <p>' . ERROR_MAILBEEZ_UPDATE_REQUIRED . '</p>
                <p><a href="' . $mailbeezUpdaterUrl . '" class="btn btn-default" style="display: inline-block">' . BUTTON_MAILBEEZ_UPDATE . '</a></p>
              </span>';
    }
}
